module Date where

data Date  = Date Int Month Int
data Month = Jan | Feb | Mar | Apr | May | Jun 
           | Jul | Aug | Sep | Oct | Nov | Dec

today     = Date 25 Oct 2016
bloomsday = Date 16 Jun 1904

day  :: Date-> Int
year :: Date-> Int
day  d = case d of Date t m y-> t
year (Date _ _ y) = y

yearDay :: Date-> Int
yearDay (Date d m y) = d + sumPrevMonths m where
  sumPrevMonths :: Month-> Int
  sumPrevMonths Jan = 0
  sumPrevMonths m   = daysInMonth (prev m) y + 
                      sumPrevMonths (prev m)

daysInMonth :: Month-> Int-> Int
daysInMonth Jan y = 31
daysInMonth Feb y = if leapyear y then 29 else 28
daysInMonth Mar y = 31
daysInMonth Apr y = 30  
daysInMonth May y = 31
daysInMonth Jun y = 30  
daysInMonth Jul y = 31  
daysInMonth Aug y = 31  
daysInMonth Sep y = 30  
daysInMonth Oct y = 31
daysInMonth Nov y = 30
daysInMonth Dec y = 31

prev :: Month-> Month    
prev Feb = Jan
prev Mar = Feb
prev Apr = Mar
prev May = Apr
prev Jun = May
prev Jul = Jun
prev Aug = Jul
prev Sep = Aug
prev Oct = Sep
prev Nov = Oct
prev Dec = Nov    

leapyear :: Int-> Bool
leapyear y = if mod y 100 == 0 then mod y 400 == 0 
             else mod y 4 == 0
