module Shoppe where

data Apfel = Boskoop | CoxOrange | GrannySmith 
             deriving Show

apreis :: Apfel -> Int
apreis Boskoop = 55
apreis CoxOrange = 60
apreis GrannySmith = 50

data Kaese = Gouda | Appenzeller  
             deriving Show

kpreis :: Kaese -> Double
kpreis Gouda = 1450
kpreis Appenzeller = 2270

data Artikel = 
   Apfel Apfel  | Eier
 | Kaese Kaese  | Schinken
 | Salami       | Milch Bool
 deriving Show

data Menge = Stueck Int  | Gramm  Int
           | Kilo Double | Liter  Double
           deriving Show

data Preis = Cent Int | Ungueltig 
             deriving Show

preis :: Artikel -> Menge-> Preis
preis (Apfel a) (Stueck n)  = Cent (n* apreis a)
preis Eier (Stueck n)       = Cent (n* 20)
preis (Kaese k)(Kilo kg)    = Cent (round(kg* 
                                       kpreis k))
preis Schinken (Gramm g)    = Cent (g/100* 199)
preis Salami (Gramm g)      = Cent (g/100* 159) 
preis (Milch bio) (Liter l) = 
   Cent (round (l* if not bio then 69 else 119))
preis _ _                   = Ungueltig

